package ch.zhaw.pm2.racetrack;

import java.util.ArrayList;
import java.util.List;

/**
 * Class containing the main method
 *
 * @author Roman Schenk
 */
public class Main {
    /**
     * Method creating the game and initializing the Configs and Userinterface.
     * Starts and initializes a new game until the user decides to stop the game.
     * In charge of closing the user interface when user decides to stop the game
     *
     * @param args no arguments needed
     */
    public static void main(String[] args) {
        UserInterface userInterface = new UserInterface("Hello and Welcome to Racetrack by Team02-\"AngryNerds\"");
        Config config = new Config();
        while (true) {
            Game game = new Game(userInterface, config);
            String winner;
            if (game.initPhase()) {
                winner = game.gamePhase();
                List<String> optionsNewGame = new ArrayList<>();
                optionsNewGame.add("exit");
                optionsNewGame.add("new game");
                String winnerText;
                if (winner == null) {
                    winnerText = "There was no winner.";
                } else {
                    winnerText = "The Winner was Car " + winner;
                }
                int selectedOption = userInterface.selectOption(winnerText + "\nStart new Game?", optionsNewGame);
                if (selectedOption == 0) {
                    userInterface.quit("Thank you and goodbye\npress enter to close the application.");
                    break;
                }
            } else {
                userInterface.quit("The initialisation of the game failed. Press enter to close the application.");
                break;
            }
        }

    }

}
