package ch.zhaw.pm2.racetrack.strategy;

import ch.zhaw.pm2.racetrack.PositionVector.Direction;
import ch.zhaw.pm2.racetrack.UserInterface;

/**
 * Let the user decide the next move.
 * Therefore, it uses the UserInterface class to ask for a direction.
 */
public class UserMoveStrategy implements MoveStrategy {
    private final UserInterface userInterface;
    private final int carIndex;
    private final char carID;

    public UserMoveStrategy(UserInterface userInterface, int carIndex, char carID) {
        this.userInterface = userInterface;
        this.carIndex = carIndex;
        this.carID = carID;
    }

    /**
     * Uses the interface to determine which move the user takes.
     *
     * @return the next taken move as Direction
     */
    @Override
    public Direction nextMove() {
        return userInterface.selectDirection(carIndex, carID);
    }
}
